{{- define "libdjango.django-deployment.tpl" }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ .Release.Name | quote }}
  labels:
    {{- include "libdjango.labels" . | nindent 4 }}
    app.kubernetes.io/component: django
spec:
  {{- if not .Values.django.autoscaling.enabled }}
  replicas: {{ .Values.django.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "libdjango.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations: { }
      labels:
        {{- include "libdjango.selectorLabels" . | nindent 8 }}
        {{- include "libdjango.versionLabels" . | nindent 8 }}
        app.kubernetes.io/component: django
    spec:
      {{- with .Values.image.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "libdjango.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.django.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
                  {{- toYaml .Values.django.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          {{- with .Values.django.command }}
          command:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          envFrom:
            - configMapRef:
                name: "{{ .Release.Name }}-config"
            - secretRef:
                name: "{{ .Release.Name }}-secrets"
          ports:
            - name: django
              containerPort: {{ .Values.django.service.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: {{ .Values.django.service.livenessProbePath }}
              port: django
            initialDelaySeconds: 10
            failureThreshold: 3
            periodSeconds: {{ .Values.django.service.livenessProbePeriodSeconds | default 5 }}
            timeoutSeconds: {{ .Values.django.service.livenessProbeTimeoutSeconds | default 1 }}
          readinessProbe:
            httpGet:
              path: {{ .Values.django.service.readinessProbePath }}
              port: django
            initialDelaySeconds: 10
            failureThreshold: 3
            periodSeconds: {{ .Values.django.service.readinessProbePeriodSeconds | default 5 }}
            timeoutSeconds: {{ .Values.django.service.readinessProbeTimeoutSeconds | default 1 }}
          resources:
            {{- toYaml .Values.django.resources | nindent 12 }}
      {{- with .Values.django.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.django.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.django.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
{{- end }}
{{- define "libdjango.django-deployment" -}}
{{- include "libdjango.merge" (append . "libdjango.django-deployment.tpl") -}}
{{- end -}}
